import 'package:flutter/material.dart';

import '../get_main.dart';

class GetState extends State {
  Map<GetState, State> _stateMap = {};

  rebuildWidgets(GetState id) {
    if (id != null) {
      final State state = _stateMap[id];
      if (state != null && state.mounted) state.setState(() {});
    }
  }

  @override
  Widget build(BuildContext context) {
    return throw ("You don't can call build function");
  }
}

class Getbuild<T extends GetState> extends StatefulWidget {
  @required
  final Widget Function(T) builder;
  final bool global;
  final bool autoRemove;
  final void Function(State state) initState, dispose, didChangeDependencies;
  final void Function(Getbuild oldWidget, State state) didUpdateWidget;
  final T getState;
  Getbuild({
    Key key,
    this.getState,
    this.global = true,
    this.builder,
    this.autoRemove = true,
    this.initState,
    this.dispose,
    this.didChangeDependencies,
    this.didUpdateWidget,
  })  : assert(builder != null, getState != null),
        super(key: key);
  @override
  _GetbuildState<T> createState() => _GetbuildState<T>();
}

class _GetbuildState<T extends GetState> extends State<Getbuild<T>> {
  T getState;
  @override
  void initState() {
    super.initState();

    if (widget.global) {
      if (Get.isRegistred<T>()) {
        getState = Get.find<T>();
      } else {
        getState = widget.getState;
        getState._stateMap[getState] = this;
        Get.put(getState);
      }
    } else {
      getState = widget.getState;
      getState._stateMap[getState] = this;
    }

    if (widget.initState != null) widget.initState(this);
  }

  @override
  void dispose() {
    if (getState != null) {
      var b = getState;
      if (b._stateMap[getState].hashCode == this.hashCode) {
        b._stateMap.remove(getState);
      }
    }

    if (widget.dispose != null) widget.dispose(this);
    if (widget.autoRemove) {
      if (Get.isRegistred<T>()) {
        Get.delete(getState);
      }
    }
    super.dispose();
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    if (widget.didChangeDependencies != null)
      widget.didChangeDependencies(this);
  }

  @override
  void didUpdateWidget(Getbuild oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (widget.didUpdateWidget != null) widget.didUpdateWidget(oldWidget, this);
  }

  @override
  Widget build(BuildContext context) {
    return widget.builder(getState);
  }
}
